PROGRAM Transf (infile, outfile);
   (* version 2.0 *)

CONST maxspecie = 10;   (* maximum number of species *)
   maxlocus  = 10;      (* maximum number of loci *)
   maxchar   = 40;      (* maximum number of alleles *)
   namesize  = 10;      (* length of species name *)

VAR specie   : ARRAY[1..maxspecie] OF ARRAY[1..namesize] OF CHAR;
   locus     : ARRAY[1..maxlocus] OF INTEGER;
   xbar      : ARRAY[0..maxchar] OF REAL;
   numspecie, numloci, nalleles, p, i, j, k, m, n : INTEGER;
   infile, outfile    : TEXT;
   sum       : REAL;
   freqs, sines : ARRAY[1..maxspecie] OF ARRAY[1..maxchar] OF REAL;

PROCEDURE fetchdata;
   VAR i, j, k : INTEGER;
BEGIN (* fetchdata *)
   READ(infile, numspecie);
   IF EOLN(infile) THEN READLN(infile);
   READLN(infile,numloci);
   FOR i := 1 TO numloci DO BEGIN
      IF EOLN(infile) THEN READLN(infile);
      READ(infile, locus[i]);
      END;
   READLN(infile);
   nalleles := 0;
   FOR i := 1 TO numloci DO nalleles := nalleles + locus[i] - 1;
   FOR j := 1 TO numspecie DO BEGIN
      FOR i := 1 TO namesize DO READ(infile, specie[j,i]);
      FOR i := 1 TO nalleles DO BEGIN
         IF EOLN(infile) THEN READLN(infile);
         READ(infile, freqs[j,i]);
         END;
      READLN(infile);
      END;
END; (* fetchdata *)

PROCEDURE storedata;
   VAR i, j, m : INTEGER;
BEGIN (* storedata *)
   WRITELN(outfile, numspecie, '  ', n);
   FOR i := 1 TO numspecie DO BEGIN
      FOR j := 1 TO namesize DO WRITE(outfile, specie[i,j]);
      FOR j := 1 TO nalleles DO BEGIN
         IF (j MOD 9) = 0
         THEN BEGIN
            WRITELN(outfile);
            FOR m := 1 TO namesize DO WRITE(outfile, ' ');
            WRITE(outfile, '  ');
            END;
         WRITE(outfile, sines[i,j]:6:4);
         END;
      WRITELN(outfile);
      END;
END; (* storedata *)

BEGIN (* main program *)
   REWRITE(outfile);
   RESET(infile);
   fetchdata;
   (* now translate freqs into sines *)
   FOR j := 1 TO numspecie DO BEGIN
      k := 0;
      FOR i := 1 TO numloci DO BEGIN
         sum := 0.0;
         FOR m := 1 TO locus[i] - 1 DO BEGIN
            k := k + 1;
            sines[j,k] := sqrt(freqs[j,k]/(1.0 - sum));
            sum := sum + freqs[j,k];
            END;
         END;
      END;
   (* accumulate average frequencies *)
   p := 0;
   FOR i := 1 TO numloci DO BEGIN
      FOR k := 1 TO locus[i]-1 DO BEGIN
         p := p + 1;
         sum := 0;
         FOR j := 1 TO numspecie DO sum := sum + freqs[j,p];
         xbar[p] := sum/numspecie;
         END;
      END;
   n := 0;
   FOR i := 1 TO numloci DO BEGIN
      sum := 0.0;
      FOR j := 1 TO locus[i]-1 DO BEGIN
         n := n + 1;
         FOR m := 1 TO numspecie DO
            sines[m,n] := (1 - sqrt(1.0 - sum))
                * xbar[n] + sqrt(1.0 - sum) * sines[m,n];
         sum := sum + xbar[n];
         END;
      END;
   (* now write to output file *)
   storedata;
   (*    CLOSE (outfile);  -- may need this here *)
END.
